<?php

namespace Teknisa\ACL\Controllers;

use Teknisa\Libs\Controller\CRUD;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO;
use Teknisa\ACL\Util\InstanceProvider;
use Teknisa\ACL\Util\AclUtilities;

class PerfAcessGremprGrupoempr extends CRUD{
    public function save(DTO\Request $request, DTO\Response $response) {
        return parent::save($request, $response);
    }

    public function delete(DTO\Request $request, DTO\Response $response) {
        return parent::delete($request, $response);
    }

    public function savePerfAcessGremprGrupoempr(DTO\Request\DataSet $request, DTO\Response $response) {
        $request->setParameter('dbname', 'perfacessgrempr_grupoempr');
        $this->save($request, $response);
        $row = $request->getDataSet()->getRows()[0];
        $labels = $row['ACL_LABELS_TRADUCTION_LOG'];
        $arrayValores = [$labels['label'], $row['DSGRUPEMPR'],  $row['CDGRUPEMPR']];
        $arrayNomes = ['Tela',  $labels['DSGRUPEMPR'], $labels['CDGRUPEMPR']];
        $descricao = AclUtilities::gerarDescricao($arrayValores, $arrayNomes);
        InstanceProvider::getLibLog()->logRegister($row['NRPERFILACESSO'].'_'.$row['CDGRUPEMPR'], $descricao, '1', 'PERFACESSGREMPR', '/crud/perfacessgrempr_grupoempr/save');
    }

    public function removePerfAcessGremprGrupoempr(DTO\Request $request, DTO\Response $response ) {
        $request->setParameter('dbname', 'perfacessgrempr_grupoempr');
        $this->delete($request, $response);
        $row = $request->getParameters()["row"];
        $labels = $row['ACL_LABELS_TRADUCTION_LOG'];
        $arrayValores = [$labels['label'], $row['NRPERFILACESSO'], $row['CDGRUPEMPR']];
        $arrayNomes = ['Tela', $labels['NRPERFILACESSO'], $labels['CDGRUPEMPR']];
        $descricao = AclUtilities::gerarDescricao($arrayValores, $arrayNomes);
        InstanceProvider::getLibLog()->logRegister($row['NRPERFILACESSO'].'_'.$row['CDGRUPEMPR'], $descricao, '3', 'PERFACESSGREMPR', '/crud/perfacessgrempr_grupoempr/remove');
    }
    
    public function saveGrupoEmpr(DTO\Request\DataSet $request, DTO\Response $response) {
        $request->setParameter('dbname', 'grupoempr');
        $this->save($request, $response);
        $row = $request->getDataSet()->getRows()[0];
        $labels = $row['ACL_LABELS_TRADUCTION_LOG'];
        $grupoempr =  InstanceProvider::getPerfAcessGremprGrupoempr()->findGrupoEmpr($row['DSGRUPEMPR']);
        $arrayValores = [$labels['label'], $row['DSGRUPEMPR'], $row['CDGRUPEMPR']];
        $arrayNomes = ['Tela', $labels['DSGRUPEMPR'], $labels['CDGRUPEMPR']];
        $descricao = AclUtilities::gerarDescricao($arrayValores, $arrayNomes);
        InstanceProvider::getLibLog()->logRegister($grupoempr[0]['CDGRUPEMPR'], $descricao, '1', 'GRUPOEMPR', '/crud/grupoempr/save');
    }

    public function removeGrupoEmpr(DTO\Request $request, DTO\Response $response) {
        $request->setParameter('dbname', 'grupoempr');
        $this->delete($request, $response);
        $row = $request->getParameters()["row"];
        $labels = $row['ACL_LABELS_TRADUCTION_LOG'];
        $arrayValores = [$labels['label'], $row['CDGRUPEMPR']];
        $arrayNomes = ['Tela', $labels['CDGRUPEMPR']];
        $descricao = AclUtilities::gerarDescricao($arrayValores, $arrayNomes);
        InstanceProvider::getLibLog()->logRegister($row['CDGRUPEMPR'], $descricao, '3', 'GRUPOEMPR', '/crud/grupoempr/remove');
    }

}